#!/usr/bin/perl
use strict;
use warnings;

        ######################################################
   ##########################          ############################
############################   FPEdit   ##############################
   ##########################          ############################
        ######################################################


#Edit 07-08-2010 - the blinky cursor no longer displays in the right position because it was
#causing errors, so I commented it out. see lines 1155 and 1171 and 1191. For now I'll leave it as is
#but at the moment, my recommended solution would be switching to a fixed width font so that
#I don't have to figure out the width of each letter.


######################################################################
####                           FPEdit                             ####
####                  Created by flying_popcorn                   ####
####  License: http://creativecommons.org/licenses/by-nc-sa/3.0/  ####
######################################################################


######################################################################
####                   Requires Perl SDL Modules                  ####
######################################################################


######################################################################
####                          HOW TO RUN                          ####
####                  Make sure file is executable:               ####
####                chmod a+x /path/to/bzmapeditor.pl             ####
####          Make sure you have perl and the SDL modules         ####
####                         Run cd /path/to/                     ####
####                       Run ./bzmapeditor.pl                   ####
######################################################################

#########################################################################
# For more information, read the manual included in the zip this script #
# came in. ##############################################################
############

use SDL;
use SDL::App;
use SDL::Surface;
use SDL::Cursor;
use SDL::Event;
use SDL::TTFont;
#start sdl

my $app = new SDL::App(-title=>'FPEdit',-width=>1000,-height=>700,-depth=>32,-flags=>SDL_DOUBLEBUF | SDL_HWSURFACE | SDL_HWACCEL, -resizeable => 1);#create the window

my $window_width=1000;
my $window_height=700;
my @frozen=();#Freeze game until certain button is pressed
my $frozentype="";


###misc variables
my @keydowns;#keys pressed down in the current frame
my @keyups;#keys released in the current frame


###GAME GLOBAL VARIABLES
my $black = new SDL::Color(-r=>0, -g=>0, -b=>0);#make colors
my $white = new SDL::Color(-r=>215, -g=>215, -b=>215);#make colors
my $selection = new SDL::Color(-r=>255, -g=>255, -b=>255);#make colors
my $lightgray = new SDL::Color(-r=>240, -g=>240, -b=>240);
my $blue = new SDL::Color(-r=>0, -g=>0, -b=>255);#make colors
my $red = new SDL::Color(-r=>255, -g=>25, -b=>25);#make colors
my $fgcolor = new SDL::Color(-r=>0, -g=>255, -b=>30);
my @fgcolorarray = ();$fgcolorarray[$_] = new SDL::Color(-r=>0, -g=>255, -b=>30+$_*9) foreach(1..25);#make colors
my $bdcolor = new SDL::Color(-r=>170, -g=>0, -b=>255);#make colors
my @selected=();
my $selectedtextbox=0;
my $extracode="";
my $movementsnap=5;#How much to snap
my $resizingsnap=5;
my $zoom=1;#How far zoomed in it is
my $view_x=-410;#The position of the view
my $view_y=-410;
my $zmin=0;
my $zmax=30;
my $shiftdown=0;#if shift is being held down
my $ctrldown=0;#if ctrl is being held down
my $xdown=0;#etc
my $ndown=0;
my $xtb;#Textbox with object's x values
my $ytb;
my $ztb;
my $xsizetb;#etc
my $ysizetb;
my $zsizetb;
my $morecodetb;
my $nametb;
my $groupmovement;
my $save="0";
my $load="0";
my $namedefault="1";
my $left=0;my $right=0;my $up=0;my $down=0;
my $objecttypeselected="Bx";
my $textfont = new SDL::TTFont(-name=>"./Vera.ttf", -size=>12, -bg=>$fgcolor, -fg=>$black);
my $textboxfont = new SDL::TTFont(-name=>"./Vera.ttf", -size=>12, -bg=>$selection, -fg=>$black);
my $controlfont = new SDL::TTFont(-name=>"./Vera.ttf", -size=>12, -bg=>$white, -fg=>$black);
my $controlfontred = new SDL::TTFont(-name=>"./Vera.ttf", -size=>12, -bg=>$white, -fg=>$red);
my $controlfontblack = new SDL::TTFont(-name=>"./Vera.ttf", -size=>12, -bg=>$black, -fg=>$white);
my $largeredfont = new SDL::TTFont(-name=>"./Vera.ttf", -size=>48, -bg=>$black, -fg=>$red);
###END GAME GLOBAL VARIABLES

my @objects;#array of all objects in the current room
#Create some objects to start off with
new worldboundry;#Blue border around the map
my $ctrler=new controller;#The controller. Controls Everything.
new objectselector;
new saveload;

my $event= new SDL::Event;
&event_loop();#Start the event loop executing



##################--------------MAIN EVENT LOOP -----------------#################
sub event_loop 
{#the game will spend its entire time here. It will loop and catch events.
	my $next_heartbeat = $app->ticks;#Next time that a frame will be drawn. Set it to the current time
	MAIN_LOOP:
	while(1) 
	{#Start the loop. Make it execute forever and only quit when esc or the close button is pressed
		while ($event->poll) 
		{#Go thru all the events in the queue
			my $type = $event->type();#Get the type of event

			last MAIN_LOOP if ($type == SDL_QUIT);#If the close button or the escape key was pressed, quit the loop which will end the game.
			last MAIN_LOOP if ($type == SDL_KEYDOWN && $event->key_name() eq 'escape');
			push(@keydowns,$event->key_name()) if($type == SDL_KEYDOWN);#If a keyboard key is pressed, run all object's keyboard event.
			push(@keyups,$event->key_name()) if($type == SDL_KEYUP);#If a keyboard key is pressed, run all object's keyboard event.
			
			if($type==SDL_VIDEORESIZE)
			{
				$window_width=$event->resize_w();$window_height=$event->resize_h();
				if($window_width>750&&$window_height>550){$app->resize($window_width,$window_height);} 
				if($window_width<750){$window_width=750;}
				if($window_height<550){$window_height=550;}
				&handle_windowresize();
			} #Resizing window
			
			push(@keydowns,"mb".$event->button()) if($type == SDL_MOUSEBUTTONDOWN());#Same if the mouse button is pressed
			push(@keyups,"mb".$event->button()) if($type == SDL_MOUSEBUTTONUP());
		}
        
		if ($app->ticks >= $next_heartbeat) 
		{
     		#If enough time has passed since the last frame ("heartbeat"), then display the next frame and set the timer for the next frame.
			&heartbeat;#Run function
			$next_heartbeat = $app->ticks + 12;#Set timer for next frame
		}     
		$app->delay(4);#Delay the event loop a few miliseconds to keep it from using 100% cpu.
	}
}

##################--------------HEARTBEAT FUNCTION-----------------#################
sub heartbeat 
{#The frame function ("heartbeat"). It runs the frame event of all the objects and draws everything.	
	
	&executeframes() unless(@frozen); #This function executes all the frame events of every object, sends events to objects, etc.
	unless(@frozen)
	{	&drawscreen();#This function draws the screen, draws sprites, and also executes the draw event of objects.
		$app->sync();#update the screen
	}else{&handle_frozen();}
	
	return undef;#Return nothing
}

sub executeframes 
{
	
	#This function executes all the frame events of every object, sends events to objects, etc. Only execute if the Z is between ZMIN and ZMAX!
	foreach(@objects){$_->framedefault() if($_&&$_->{savecheckz});}#execute the frame event of each object (default)
	foreach(@objects){$_->frame() if($_&&$_->{savecheckz});}#(custom frame event)
	
	{my $k;#create temp variables
	foreach $k (@keydowns){foreach (@objects){$_->keydown($k) if($_&&$_->{savecheckz});}}#execute the keyup & keydown events for every object and every keyup/down
	foreach $k (@keyups){foreach (@objects){$_->keyup($k) if($_&&$_->{savecheckz});}}
	@keydowns=(); @keyups=();}
	
	foreach(@objects){$_->framedefaultafter() if($_&&$_->{savecheckz})};# (default, after custom)
	return undef;#Return nothing
}

sub drawscreen
{
	#This function draws the screen, draws sprites, and also executes the draw event of objects.
	
	$app->fill(0, $black);#Redraw the background
	
	foreach(@objects){if($_&&$_->{"visible"}&&$_->{savecheckz})
	{
		if($_->{"sprite"}&&$_->{"drawsprite"}){$_->{"sprite"}->blit(0, $app, $_->{"newrect"});}#If they have a sprite and are set up to draw their sprite, draw their sprite
		if($_->{"usedrawevent"}){$_->draw;}#If the object is set up to use the draw event, use the draw event.
	}}#Go thru all objects and draw their sprite and/or execute their draw event
	
	$app->sync();#update the screen
	return undef;#Return nothing
}

sub handle_frozen
{#Frozen is when the screen is frozen and a yes no or OK message pops up on screen.
	@keyups=();
	if(@keydowns)
	{
		my $key;
		my $selectedkey;
		unless($frozen[0] eq "all")
		{
			#All means end on all keys.
			@keydowns=grep {&checkfrozenkeys($_);} @keydowns;

			#Remove all keys that aren't un-freeze keys.
		}
		if(@keydowns==1)
		{
			my $var=$keydowns[0];
			@keydowns=();
			@frozen=();
			foreach(@objects){$_->unfreeze($var,$frozentype) if($_&&$_->checkz());}
		}#Un-freeze if there are unfreeze keys pressed
		@keydowns=();
	}
	
}
sub checkfrozenkeys
{
	my $key=@_;
	foreach $key (@frozen)
	{
		if($key eq $_){return 1;}#if it finds the key return true.
	}
	return 0;
}

sub handle_windowresize
{#uPdate Y positions of textboxes on the bottom part of the control panel
	$xtb->{y}=$window_height-140;$xtb->updaterects();
	$ytb->{y}=$window_height-90;$ytb->updaterects();
	$ztb->{y}=$window_height-40;$ztb->updaterects();
	$xsizetb->{y}=$window_height-140;$xsizetb->updaterects();
	$ysizetb->{y}=$window_height-90;$ysizetb->updaterects();
	$zsizetb->{y}=$window_height-40;$zsizetb->updaterects();
	$morecodetb->{y}=$window_height-185;$morecodetb->updaterects();
	$nametb->{y}=$window_height-185;$nametb->updaterects();
}

package objectdefault;
	#The default object class. This contains basic variables and functions that every object will have.
	sub new 
	{
		my ($class) = @_;#pull out the arguments
		my $self = {
		x => 0,
		y => 0,
		xprevious => 0,
		yprevious => 0,
		sprite => undef,
		sprite_width => undef,
		sprite_height => undef,
		oldrect => undef,
		newrect => undef,
		hspeed => 0,
		vspeed => 0,
		oldvisible => 0,
		visible => 1,
		drawsprite => 1,
		usedrawevent => 0,
		depth => 0,
		savecheckz => 1,
		objecttype => "unknown"};#Set up all the default variables
		bless $self, $class;#Create the object
		$self->create();#Run the create event for the object
		push(@objects,$self);#Add the object to the all objects array
		return $self;#Return the ID for the object
	}
	
	sub framedefault
	{
		my($self)=@_;
		$self->{xprevious}=$self->{x};#execute this before the frame event... set up xprevious, yprevious
		$self->{yprevious}=$self->{y};
		#$self->{"oldrect"}->x($self->{"xprevious"});#Set up the old rectangle
          #$self->{"oldrect"}->y($self->{"yprevious"});
		$self->{x}+=$self->{hspeed};#add hspeed and vspeed values
		$self->{y}+=$self->{vspeed};
		$self->{oldvisible}=$self->{visible};#set if it was visible last frame
	}
	
	sub framedefaultafter
	{
		my($self)=@_;
		if($self->{sprite}&&$self->{visible})
		{
			$self->{newrect}->x($self->{x});#afterwords, set up the new rectangle
          	$self->{newrect}->y($self->{y});
          }
	}
	
	sub load_sprite
	{
		my($object,$sprite_path)=@_;#function ofor loading the sprite.. set up the newrectangle and the oldrectangle and load the image.
		$object->{sprite}=new SDL::Surface(-name=>$sprite_path);
		$object->{newrect}=new SDL::Rect(-width=>$object->{sprite}->width(), -height=>$object->{sprite}->height());
		#$object->{"oldrect"}=new SDL::Rect(-width=>$object->{"sprite"}->width(), -height=>$object->{"sprite"}->height());
	}
	
	sub instance_destroy
	{
		my($self)=@_;
		@objects=grep($_!=$self,@objects);#Remove the object
		undef $self;
	}
	
	sub sortdepths
	{
		@objects = sort { if($a&&$b)     {$b->{depth} <=> $a->{depth}}     else{0;} } @objects;#A function for sorting depths.
		return undef;
	}
	
	sub checkz
	{
		my($self)=@_;
		$self->{savecheckz}=1;
		return $self->{savecheckz};
	}
	
	sub create{}#Set the defualt functions
	sub frame{}#This is the frame function. It will be executed every frame
	sub draw{}#This is the draw event. It will be executed every frame and you can draw stuff on the screen in this event
	sub keydown{}#When a key is pressed down
	sub keyup{}#When a key is released
	sub unfreeze{}#When a frozen screen is unfrozen.
	

package worldboundry;
	BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{#This object draws blue lines around the standard 400x400 map size
		my($self)=@_;
		$self->{depth}=9999999999999999999;#Make sure it appears under everything else
		$self->{usedrawevent}=1;
		$self->{leftborder}=new SDL::Rect();#A rectangle for each
		$self->{rightborder}=new SDL::Rect();
		$self->{topborder}=new SDL::Rect();
		$self->{bottomborder}=new SDL::Rect();
		$self->{drawleftborder}=0;#Whether its in the view/zoom (whether or not to draw it)
		$self->{drawrightborder}=0;
		$self->{drawtopborder}=0;
		$self->{drawbottomborder}=0;
		$self->{objecttype}="worldboundry";
	}
	
	sub frame
	{
		my($self)=@_;my $x;my $y;my $width;my $height;
		foreach(@selected){$_->{selected}=1;}#Set the frame-temporary variable selected to true for all selected objects.
		#Calculate each rect for the borders. Find out where in the window it is from the zoom value and view movement. Then make it as small as possible with max and min so that it the rects are only inside the window. Then check if the rect is inside the window or not, if it is, mark it to be drawn.
		$x=-400*$zoom-$view_x-10+200;
		$y=$self->max(0,-400*$zoom-$view_y);
		$width=10;
		$height=$self->min($window_height-200,(400*$zoom-$view_y)-$y);
		$self->{drawleftborder}=$x>=190&&$x<=$window_width&&$y>=-10&&$y<=$window_height-200&&(400*$zoom-$view_y)-$y>=0;
		$self->{leftborder}->x($x);$self->{leftborder}->y($y);$self->{leftborder}->width($width);$self->{leftborder}->height($height);

		$x=400*$zoom-$view_x+200;
		$y=$self->max(0,-400*$zoom-$view_y);
		$width=10;
		$height=$self->min($window_height-200,(400*$zoom-$view_y)-$y);
		$self->{drawrightborder}=$x>=190&&$x<=$window_width&&$y>=-10&&$y<=$window_height-200&&(400*$zoom-$view_y)-$y>=0;
		$self->{rightborder}->x($x);$self->{rightborder}->y($y);$self->{rightborder}->width($width);$self->{rightborder}->height($height);
		
		$x=$self->max(200,-400*$zoom-$view_x-10+200);
		$y=-400*$zoom-$view_y-10;
		$width=$self->min($window_width,(400*$zoom-$view_x)-$x+200+10);
		$height=10;
		$self->{drawtopborder}=$x>=200&&$x<=$window_width&&$y>=-10&&$y<=$window_height-200&&(400*$zoom-$view_x)-$x+200>=0;
		$self->{topborder}->x($x);$self->{topborder}->y($y);$self->{topborder}->width($width);$self->{topborder}->height($height);
		
		$x=$self->max(200,-400*$zoom-$view_x-10+200);
		$y=400*$zoom-$view_y;
		$width=$self->min($window_width,(400*$zoom-$view_x)-$x+200+10);
		$height=10;
		$self->{drawbottomborder}=$x>=200&&$x<=$window_width&&$y>=-10&&$y<=$window_height-200&&(400*$zoom-$view_x)-$x+200>=0;
		$self->{bottomborder}->x($x);$self->{bottomborder}->y($y);$self->{bottomborder}->width($width);$self->{bottomborder}->height($height);

	}
	
	sub draw
	{
		my($self)=@_;
		$app->fill($self->{leftborder},$blue) if($self->{drawleftborder});
		$app->fill($self->{rightborder},$blue) if($self->{drawrightborder});
		$app->fill($self->{topborder},$blue) if($self->{drawtopborder});
		$app->fill($self->{bottomborder},$blue) if($self->{drawbottomborder});
	}
	
	sub min{my($self,$v1,$v2)=@_;if($v1<$v2){return $v1;}else{return $v2;}}
	sub max{my($self,$v1,$v2)=@_;if($v1>$v2){return $v1;}else{return $v2;}}
	

package controller;
	BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{
		my($self)=@_;
		$self->{leftcontrolrect}=new SDL::Rect(-x => 0, -y => 0, -width => 200);# The white areas for the control panel
		$self->{bottomcontrolrect}=new SDL::Rect(-x => 200, -height=>200);#The white areas for the control panel
		$self->{usedrawevent}=1;#use the draw event with this object
		$self->{depth}=-99999999999999999998;#Make sure it appears on top of the objects (other than textboxes).
		$self->{sortdepthsnextframe}=1;#whether depths should be sorted next frame or not.
		$self->{mouse_right}=0;$self->{old_mx}=0;$self->{old_my}=0;
		$self->{selectionstartx}=0;
		$self->{selectionstarty}=0;
		$self->{selectionx}=0;
		$self->{selectiony}=0;
		$self->{selectionleft}=new SDL::Rect(-width => 3);
		$self->{selectionright}=new SDL::Rect(-width => 3);
		$self->{selectiontop}=new SDL::Rect(-height => 3);
		$self->{selectionbottom}=new SDL::Rect(-height => 3);
		$self->{newobjectselection}=0;
		$self->{oldzoom}=0;
		$self->{objecttype}="control";
		$self->{oldmovementsnap}=0;$self->{oldresizingsnap}=0;
		$zmin=0;$zmax=30;$self->{oldzmin}=$zmin;$self->{oldzmax}=$zmax;
		$self->setuptextboxes();
	}
	
	sub frame
	{
		my($self)=@_;
		$self->{leftcontrolrect}->height($window_height);#Set the rect's positions and widths depending on the size of the window
		$self->{bottomcontrolrect}->y($window_height-200);
		$self->{bottomcontrolrect}->width($window_width-200);
		if($self->{sortdepthsnextframe}){$self->sortdepths();$self->{sortdepthsnextframe}=0;}
		
		$view_x-=15 if($left);#move the view
		$view_x+=15 if($right);
		$view_y-=15 if($up);
		$view_y+=15 if($down);
		
		if($self->{mouse_right})
		{#Holding down the right mouse button moves the view
			$view_x-=$event->motion_x()-$self->{old_mx};
			$view_y-=$event->motion_y()-$self->{old_my};
			$self->{old_mx}=$event->motion_x();
			$self->{old_my}=$event->motion_y();
		}
		
		if((scalar @selected)!=1)
		{
			$xtb->{variable}=0;$ytb->{variable}=0;$ztb->{variable}=0;
			$xtb->{value}="0";$ytb->{value}="0";$ztb->{value}="0";
			$xsizetb->{variable}=0;$ysizetb->{variable}=0;$zsizetb->{variable}=0;
			$xsizetb->{value}="0";$ysizetb->{value}="0";$zsizetb->{value}="0";
			$nametb->{variable}=0;$morecodetb->{variable}=0;
			$nametb->{value}="0";$morecodetb->{value}="0";
		}
		
		if($self->{oldzmin} != $zmin   ||   $self->{oldzmax} != $zmax)
		{
			#If zmin and zmax have changed, have all objects recheck if they're within Z.
			foreach(@objects){$_->checkz() if($_);}
		}
		$self->{oldzmin}=$zmin;$self->{oldzmax}=$zmax;
	}
		
	sub keydown
	{
		my($self,$key)=@_;
		
		$zmin+=10 if $key eq "a" && $selectedtextbox==0;
		$zmax+=10 if $key eq "a" && $selectedtextbox==0;
		$zmin-=10 if $key eq "z" && $selectedtextbox==0;
		$zmax-=10 if $key eq "z" && $selectedtextbox==0;
		
		if($key eq "mb1"&&$event->motion_x()>200&&$event->motion_y()<$window_height-200&&!$shiftdown)
		{#If the mouse button is being held down, draw a box between the start position and the current position. (for selecting boxes)
			$self->{selectionstartx}=$event->motion_x();
			$self->{selectionstarty}=$event->motion_y();
			if($ndown)
			{#If N is down, we need to create a new box
				$self->{newobjectselection}=1;
				#make the selection snap;#snap to the reszing snap instead of movement snap because we are snapping the topleft corner and not the middle
				$self->{selectionstartx}=(int((($event->motion_x()-200+$view_x)/$zoom)/$resizingsnap/2-0.5)*$resizingsnap*2)*$zoom+200-$view_x;
				$self->{selectionstarty}=(int((($event->motion_y()+$view_y)/$zoom)/$resizingsnap/2-0.5)*$resizingsnap*2)*$zoom-$view_y;
			}
		}
		$ndown=1 if($key eq "n");#Set ndown to true if N was pressed
		$xdown=1 if($key eq "x");#Set ndown to true if N was pressed
		$shiftdown=1 if($key =~ /shift/);
		if($key =~ /ctrl/)
		{
			$ctrldown=1;
			#ctrl means no-snap. Temp set all snap values to 1.
			$self->{oldmovementsnap}=$movementsnap;$self->{oldresizingsnap}=$resizingsnap;
			$movementsnap=1;$resizingsnap=0.5;
		}
		if($key eq "mb4"&&$zoom<50)
		{#Zoom in!
			$zoom*=1.1;
			$zoom=int($zoom*10+.5)/10; #Round to the nearest tenth
		}
		if($key eq "mb5"&&$zoom>0.5)
		{#Zoom out!
			$zoom/=1.1;
			$zoom=int($zoom*10+.5)/10; #Round to the nearest tenth
		}
		$left=1 if($key eq "left"&&!$shiftdown);
		$right=1 if($key eq "right"&&!$shiftdown);
		$up=1 if($key eq "up"&&!$shiftdown);
		$down=1 if($key eq "down"&&!$shiftdown);
		if($key eq "mb3")
		{#right clicking moves view
			$self->{mouse_right}=1;
			$self->{old_mx}=$event->motion_x();
			$self->{old_my}=$event->motion_y();
		}
		$view_x=-400*$zoom-10 if($key eq "j" && $selectedtextbox==0);#Jump back to starting position if J is pressed
		$view_y=-400*$zoom-10 if($key eq "j" && $selectedtextbox==0);
		if($key eq "d" && $ctrldown)
		{#D means duplicate all selected objects
			my @tempselected=@selected;#Temporary store the old selected array, clear the real one.
			@selected=();
			foreach(@tempselected)
			{
				my $newobject = new box;#Duplicate the box
				$newobject->{x}=$_->{x}+20;
				$newobject->{y}=$_->{y}+20;
				$newobject->{z}=$_->{z};
				$newobject->{xsize}=$_->{xsize};
				$newobject->{ysize}=$_->{ysize};
				$newobject->{zsize}=$_->{zsize};
				$newobject->{mapobjecttype}=$_->{mapobjecttype};
				$newobject->{morecode}=$_->{morecode};
				$newobject->{name}=$_->{name}."_1";
				push(@selected,$newobject);
			}
			$self->{sortdepthsnextframe}=1;#make sure the controller is still on top of the box.
		}
		if($key eq "h" && $ctrldown)
		{#ctrl+h means flip horizontally. Flip all selected objects horizontally.
			 foreach(@selected){$_->{x}=-$_->{x};}
		}
		if($key eq "v" && $ctrldown)
		{#ctrl+v means flip vertically. Flip all selected objects vertically.
			 foreach(@selected){$_->{y}=-$_->{y};}
		}
		if($key eq "f" && $ctrldown)
		{#ctrl+f means flip. Flip all selected objects.
			 foreach(@selected)
			 {
			 	($_->{x},$_->{y})=($_->{y},$_->{x});
			 	($_->{xsize},$_->{ysize})=($_->{ysize},$_->{xsize});
			 }
		}
		$selectedtextbox=0 if($key eq "mb1");
	}
	
	sub draw
	{
		my($self)=@_;
		
		if($self->{oldzoom}!=$zoom&&$self->{oldzoom}!=0&&$zoom!=0)
		{#If the zoom has changed move the view so its centered zooming.
			$view_x=(($view_x+($window_width-200)/2))/$self->{oldzoom};
			$view_y=(($view_y+($window_height-200)/2))/$self->{oldzoom};
			$view_x=($view_x)*$zoom-($window_width-200)/2;
			$view_y=($view_y)*$zoom-($window_height-200)/2;
			#Move the views to make sure it zooms in on the center of the view.
		}
		$self->{oldzoom}=$zoom;
		
		if($self->{selectionstartx})
		{##Draw the selection rectangle.
			#Create 4 Rectangles for each side of the selection then draw them
			unless($event->motion_x()>20000)
			{#If the moused stopped moving, pick the old position
				$self->{selectionx}=$event->motion_x();
				$self->{selectiony}=$event->motion_y();
				if($self->{newobjectselection})
				{#Make it snap if a new object is being created.
					$self->{selectionx}=(int(((($event->motion_x()-200+$view_x)/$zoom)-(($self->{selectionstartx}-200+$view_x)/$zoom))/$resizingsnap/2)*$resizingsnap*2+(($self->{selectionstartx}-200+$view_x)/$zoom))*$zoom+200-$view_x;
					$self->{selectiony}=(int(((($event->motion_y()+$view_y)/$zoom)-(($self->{selectionstarty}+$view_y)/$zoom))/$resizingsnap/2)*$resizingsnap*2+(($self->{selectionstarty}+$view_y)/$zoom))*$zoom-$view_y;
				}
			}
			
			
			#Craete rectangles around the selection
			$self->{selectionleft}->x($self->min($self->{selectionstartx},$self->{selectionx}));
			$self->{selectionleft}->y($self->min($self->{selectionstarty},$self->{selectiony}));
			$self->{selectionleft}->height(abs($self->{selectiony}-$self->{selectionstarty}));
			$self->{selectionleft}->width(3);
			$app->fill($self->{selectionleft},($self->{newobjectselection}) ? $red : $selection );
			
			$self->{selectionright}->x($self->max($self->{selectionstartx},$self->{selectionx})-3);
			$self->{selectionright}->y($self->min($self->{selectionstarty},$self->{selectiony}));
			$self->{selectionright}->height(abs($self->{selectiony}-$self->{selectionstarty}));
			$self->{selectionright}->width(3);
			$app->fill($self->{selectionright},($self->{newobjectselection}) ? $red : $selection );
			
			$self->{selectiontop}->x($self->min($self->{selectionstartx},$self->{selectionx}));
			$self->{selectiontop}->y($self->min($self->{selectionstarty},$self->{selectiony}));
			$self->{selectiontop}->width(abs($self->{selectionx}-$self->{selectionstartx}));
			$self->{selectiontop}->height(3);
			$app->fill($self->{selectiontop},($self->{newobjectselection}) ? $red : $selection );
			
			$self->{selectionbottom}->x($self->min($self->{selectionstartx},$self->{selectionx}));
			$self->{selectionbottom}->y($self->max($self->{selectionstarty},$self->{selectiony})-3);
			$self->{selectionbottom}->width(abs($self->{selectionx}-$self->{selectionstartx}));
			$self->{selectionbottom}->height(3);
			$app->fill($self->{selectionbottom},($self->{newobjectselection}) ? $red : $selection );
		}
		
		
		$app->fill($self->{leftcontrolrect},$white);#Fill the control rect's with white.
		$app->fill($self->{bottomcontrolrect},$white);
		
		$controlfont->print($app,10,95,"Movement");#Print text next to all the textboxes.
		$controlfont->print($app,10,107,"Snap:");
		$controlfont->print($app,10,131,"Resizing");
		$controlfont->print($app,10,144,"Snap:");
		$controlfont->print($app,10,164,"(Hold Ctrl for no snap)");
		$controlfont->print($app,10,192,"Zmin:");
		$controlfont->print($app,10,222,"Zmax:");
		$controlfont->print($app,10,262,"Zoom:");
		$controlfont->print($app,10,282,"(Use mouse wheel to zoom)");
		$controlfont->print($app,230,$window_height-183,"Name");
		$controlfont->print($app,230,$window_height-138,"X");
		$controlfont->print($app,230,$window_height-88,"Y");
		$controlfont->print($app,230,$window_height-38,"Z");
		$controlfont->print($app,380,$window_height-138,"X-Size");
		$controlfont->print($app,380,$window_height-88,"Y-Size");
		$controlfont->print($app,380,$window_height-38,"Z-Size");
		$controlfont->print($app,470,$window_height-183,"More Code");
	}
	
	sub keyup
	{
		my($self,$key)=@_;
		$ndown=0 if($key eq "n");#Set ndown to false if N was rleased
		$xdown=0 if($key eq "x");#Set xdown to tfalse if X was released
		$shiftdown=0 if($key =~ /shift/);
		if($key =~ /ctrl/)
		{
			$ctrldown=0;
			#ctrl means no-snap. unset all snap values from 1.
			$movementsnap=$self->{oldmovementsnap} if($movementsnap==1);
			$resizingsnap=$self->{oldresizingsnap} if($resizingsnap==0.5);
		}
		$left=0 if($key eq "left");
		$right=0 if($key eq "right");
		$up=0 if($key eq "up");
		$down=0 if($key eq "down");
		$self->{mouse_right}=0 if($key eq "mb3");
		if($key eq "mb1"&&$self->{selectionstartx})
		{#End of selection
			if(abs($self->{selectionstartx}-$self->{selectionx})>10||abs($self->{selectionstarty}-$self->{selectiony})>10)
			{
				if($self->{newobjectselection})
				{#Create a new object the size of the selection
					#pre-calculate a few temporary values.
					my $tempxstart=int(($self->{selectionstartx}+$view_x-200)/$zoom);
					my $tempystart=int(($self->{selectionstarty}+$view_y)/$zoom);
					my $tempx=int(($self->{selectionx}+$view_x-200)/$zoom);
					my $tempy=int(($self->{selectiony}+$view_y)/$zoom);
					my $newobject=new box;#create the new object
					#set x y xsize and ysize to the position and size of the selection.
					$newobject->{x}=int((abs($tempx-$tempxstart)/2+$self->min($tempxstart,$tempx))/$movementsnap)*$movementsnap;
					$newobject->{y}=int((abs($tempy-$tempystart)/2+$self->min($tempystart,$tempy))/$movementsnap)*$movementsnap;
					$newobject->{z}=$zmin;
					$newobject->{xsize}=int(abs($tempx-$tempxstart)/2/$resizingsnap)*$resizingsnap;
					$newobject->{ysize}=int(abs($tempy-$tempystart)/2/$resizingsnap)*$resizingsnap;
					$newobject->{xsize}=1 if($newobject->{xsize}==0);$newobject->{ysize}=1 if($newobject->{ysize}==0);
					$newobject->{zsize}=abs($zmax-$zmin);
					$newobject->{depth}=-($newobject->{z}+$newobject->{zsize});
					$newobject->{mapobjecttype}=$objecttypeselected;
					$newobject->{xsize}=0.125 if($objecttypeselected eq "Tp"); #Teleporters always have 0.125 xsize.
					$self->{sortdepthsnextframe}=1;#make sure the controller is still on top of the box.
				}
				else
				{
					@selected=() unless($ctrldown);
					my $obj;
					foreach $obj (@objects)
					{#Get all the boxes in the selection and add them to the selected list.
						if($obj->{objecttype} eq "box"
						&&$obj->checkz()
						&&$obj->{x}*$zoom-$view_x+200>$self->min($self->{selectionstartx},$self->{selectionx})
						&&$obj->{x}*$zoom-$view_x+200<$self->max($self->{selectionstartx},$self->{selectionx})
						&&$obj->{y}*$zoom-$view_y>$self->min($self->{selectionstarty},$self->{selectiony})
						&&$obj->{y}*$zoom-$view_y<$self->max($self->{selectionstarty},$self->{selectiony}))
						{
							#if it's in the selection rectangle
							if(grep($obj==$_,@selected))
							{#It's already selected, unselect it
								@selected=grep($obj!=$_,@selected);#Remove it from the array
							}
							else
							{
								push(@selected,$obj);
							}
						}
					}
				}
			}
			$self->{selectionstartx}=0;$self->{selectionstarty}=0;$self->{newobjectselection}=0;
		}
	}
	
	sub setuptextboxes
	{#make textboxes!
		my($self)=@_;
		#make a bunch of textboxes and set their attributes.
		$xtb=new textbox;$xtb->{x}=   250   ;$xtb->{y}=   $window_height-140   ;
		$xtb->{variable}=   0   ;$xtb->updaterects();
		
		$ytb=new textbox;$ytb->{x}=   250   ;$ytb->{y}=   $window_height-90   ;
		$ytb->{variable}=   0   ;$ytb->updaterects();
		
		$ztb=new textbox;$ztb->{x}=   250   ;$ztb->{y}=   $window_height-40   ;
		$ztb->{variable}=   0   ;$ztb->updaterects();
		
		$xsizetb=new textbox;$xsizetb->{x}=   425   ;$xsizetb->{y}=   $window_height-140   ;
		$xsizetb->{variable}=   0   ;$xsizetb->updaterects();
		
		$ysizetb=new textbox;$ysizetb->{x}=   425   ;$ysizetb->{y}=   $window_height-90   ;
		$ysizetb->{variable}=   0   ;$ysizetb->updaterects();
		
		$zsizetb=new textbox;$zsizetb->{x}=   425   ;$zsizetb->{y}=   $window_height-40   ;
		$zsizetb->{variable}=   0   ;$zsizetb->updaterects();
		
		$morecodetb=new textbox;$morecodetb->{x}=   550   ;$morecodetb->{y}=   $window_height-185      ;
		$morecodetb->{width}=200;$morecodetb->{height}=165;$morecodetb->{allownewlines}=1;$morecodetb->{textboxtype}="all";
		$morecodetb->{variable}=   0   ;$morecodetb->updaterects();
		
		$nametb=new textbox;$nametb->{x}=   280   ;$nametb->{y}=   $window_height-185      ;
		$nametb->{width}=150;$nametb->{textboxtype}="all";$nametb->{value}="0";
		$nametb->{variable}=   0   ;$nametb->updaterects();
		
		my $ntb=new textbox; #$ntb = New Text Box
		$ntb->{x}=   80   ;$ntb->{y}=   100   ;#Spaces to make x and y values easy to find.
		$ntb->{variable}=   \$movementsnap   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   80   ;$ntb->{y}=   136   ;
		$ntb->{variable}=   \$resizingsnap   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   80   ;$ntb->{y}=   190   ;
		$ntb->{variable}=   \$zmin   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   80   ;$ntb->{y}=   220   ;
		$ntb->{variable}=   \$zmax   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   80   ;$ntb->{y}=   260   ;
		$ntb->{variable}=   \$zoom   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   10   ;$ntb->{y}=   5   ;$ntb->{width}=   180   ;$ntb->{allowslashes}=1;$ntb->{textboxtype}="all";
		$ntb->{variable}=   \$save   ;$ntb->updaterects();
		
		$ntb=new textbox;$ntb->{x}=   10   ;$ntb->{y}=   50   ;$ntb->{width}=   180   ;$ntb->{allowslashes}=1;$ntb->{textboxtype}="all";
		$ntb->{variable}=   \$load   ;$ntb->updaterects();
		
		
	}
	
	sub min{my($self,$v1,$v2)=@_;if($v1<$v2){return $v1;}else{return $v2;}}
	sub max{my($self,$v1,$v2)=@_;if($v1>$v2){return $v1;}else{return $v2;}}

package box;
	BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{
		my($self)=@_;
		#INIT ALL VARIABLES!
        	$self->{usedrawevent}=1;#Use the draw event
        	$self->{x}=0;$self->{xsize}=50;$self->{y}=0;$self->{ysize}=50;
        	$self->{z}=0;#init variables like x y z xsize ysize zsize etc
        	$self->{zsize}=50;
        	$self->{mainrect}=new SDL::Rect();#The rect that shows the object
        	$self->{bdrect}=new SDL::Rect();#A border around each object
        	$self->{mousedown}=0;#If the mouse button is being held down or not
        	$self->{mousestart_x}=0;#When moving objects, the starting position of the mouse
        	$self->{mousestart_y}=0;
        	$self->{start_x}=0;
        	$self->{start_y}=0;
        	$self->{start_xsize}=0;
        	$self->{start_ysize}=0;
        	$self->{selected}=0;
        	$self->{view_xold}=0;
        	$self->{view_yold}=0;
        	$self->{textx}=0;
        	$self->{texty}=0;
        	$self->{movementtype}=0;#1=x/y movement, 2=resize top right, 3=resize top left, 4=resize bottom left, 5=resize bottom right, 6=resize left, 7=resize right, 8=resize top, 9=resize bottom, 10=rotation, 11=Z movement, 12=group movement
        	$self->{objecttype}="box";
        	$self->{mapobjecttype}="Bx";
        	$self->{inview}=0;
        	$self->{displaytext}=0;
        	$self->{name}="obj".$namedefault;$namedefault++;
        	$self->{morecode}="";
        	$self->{olddepth}=$self->{depth};
        	
	}
	
	sub frame
	{
		my($self)=@_;
		$self->{depth}=-($self->{z}+$self->{zsize});#Set up depths.
		if($self->{depth}!=$self->{olddepth}){$self->sortdepths();}#Sort depths if they changed.
		$self->{olddepth}=$self->{depth};
		
		if($self->{mousedown}&&$event->motion_x()<20000&&$self->{selected})
		{	
			if($self->{movementtype}==1)
			{	
				#if the mouse button is down, sometimes $event-motion_x() gives a huge value if the mouse has not been moved. Skip movement if so., if the object is selected, if the movement type is x/y movement
				my $tempmovementsnapx=($self->{xsize}!=1)*($movementsnap-1)+1;#Make size 1 boxes move with nosnap
				my $tempmovementsnapy=($self->{ysize}!=1)*($movementsnap-1)+1;#Make size 1 boxes move with nosnap
				if($self->{ysize}==1){$self->{y}+=1};
				$self->{x}=int(($event->motion_x()/$zoom-$self->{mousestart_x}+($view_x-$self->{view_xold})/$zoom)/$tempmovementsnapx)*$tempmovementsnapx;
				$self->{y}=int(($event->motion_y()/$zoom-$self->{mousestart_y}+($view_y-$self->{view_yold})/$zoom)/$tempmovementsnapy)*$tempmovementsnapy;
				
				#First, we take the new position of the mouse minus the old position of the mouse & object. (Everything must be multiplied or divided by $zoom to make sure that zooming scales everything). Then we take the new position of the view minus the old position of the view to see how far the view moved, and move the object that far (If the view moves while moving an object). Again, we have to divide by $zoom. Then we divide everything by $movementsnap, truncate it, and multiply it by $movementsnap. This gives the effect of rounding the number to the nearest $movementsnap, which will make objects snap to a grid.
			}
			elsif($self->{movementtype}==12)
			{
				my $oldx=$self->{x};
				my $oldy=$self->{y};
				my $newx=int(($event->motion_x()/$zoom-$self->{mousestart_x}+($view_x-$self->{view_xold})/$zoom)/$movementsnap)*$movementsnap;
				my $newy=int(($event->motion_y()/$zoom-$self->{mousestart_y}+($view_y-$self->{view_yold})/$zoom)/$movementsnap)*$movementsnap;
				foreach(@selected)
				{
					$_->{x}+=$newx-$oldx;
					$_->{y}+=$newy-$oldy;
					$_->updaterects();
				}
				$groupmovement=0;#make it so that objects can get selected again.
			}
			elsif($self->{movementtype}>1&&$self->{movementtype}<10)
			{	#If it is a resize type movement, precalculate some things.
				#Resizing is similar to moving, except that you have to change both the size of the object and the position.
				my $xsizemovement=int(($event->motion_x()/$zoom-$self->{mousestart_x}+($view_x-$self->{view_xold})/$zoom)/$resizingsnap/2)*$resizingsnap;
				my $xmovement=int(($event->motion_x()/$zoom-$self->{mousestart_x}+($view_x-$self->{view_xold})/$zoom)/$resizingsnap/2)*$resizingsnap;
				my $ysizemovement=int(($event->motion_y()/$zoom-$self->{mousestart_y}+($view_y-$self->{view_yold})/$zoom)/$resizingsnap/2)*$resizingsnap;
				my $ymovement=int(($event->motion_y()/$zoom-$self->{mousestart_y}+($view_y-$self->{view_yold})/$zoom)/$resizingsnap/2)*$resizingsnap;
				
				$self->{start_xsize}=0 if($self->{start_xsize}==1);#Dont get the snap off by 1!
				$self->{start_ysize}=0 if($self->{start_ysize}==1);
				
				if($self->{movementtype}==2)
				{	$self->{xsize}=abs($self->{start_xsize}+$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					$self->{ysize}=abs($self->{start_ysize}-$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{xsize}==0){$self->{xsize}=1;}
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==3)
				{	$self->{xsize}=abs($self->{start_xsize}-$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					$self->{ysize}=abs($self->{start_ysize}-$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{xsize}==0){$self->{xsize}=1;}
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==4)
				{	$self->{xsize}=abs($self->{start_xsize}-$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					$self->{ysize}=abs($self->{start_ysize}+$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{xsize}==0){$self->{xsize}=1;}
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==5)
				{	$self->{xsize}=abs($self->{start_xsize}+$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					$self->{ysize}=abs($self->{start_ysize}+$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{xsize}==0){$self->{xsize}=1;}
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==6)
				{	$self->{xsize}=abs($self->{start_xsize}-$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					if($self->{xsize}==0){$self->{xsize}=1;}#make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==7)
				{	$self->{xsize}=abs($self->{start_xsize}+$xsizemovement);$self->{x}=$self->{start_x}+$xmovement;#change x and xsize
					if($self->{xsize}==0){$self->{xsize}=1;}#make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==8)
				{	$self->{ysize}=abs($self->{start_ysize}-$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}elsif($self->{movementtype}==9)
				{	$self->{ysize}=abs($self->{start_ysize}+$ysizemovement);$self->{y}=$self->{start_y}+$ymovement;#change y and ysize
					if($self->{ysize}==0){$self->{ysize}=1;} #make sure xsize/ysize don't get to 0.
				}
			}
			#If an object is being moved or resized, let the view be moved by putting the mouse near the edge.
			#Check if the mouse is on any side of the window, if so move that direction.
			if($event->motion_x()>$window_width-15&&$event->motion_x()<$window_width){$view_x+=($event->motion_x()-$window_width+15)*$zoom;}
			if($event->motion_x()<215&&$event->motion_x()>200){$view_x-=-($event->motion_x()-215)*$zoom;}
			if($event->motion_y()>$window_height-215&&$event->motion_y()<$window_height-200){$view_y+=($event->motion_y()-$window_height+215)*$zoom;}
			if($event->motion_y()<15&&$event->motion_y()>0){$view_y-=-($event->motion_y()-15)*$zoom;}
		}
		$self->updaterects();###############UPDATE THE RECTANGLES
		
		if($self->{selected}&&@selected==1)
		{
			$xtb->{variable}=\($self->{x});
			$ytb->{variable}=\($self->{y});
			$ztb->{variable}=\($self->{z});
			$xsizetb->{variable}=\($self->{xsize});
			$ysizetb->{variable}=\($self->{ysize});
			$zsizetb->{variable}=\($self->{zsize});
			$morecodetb->{variable}=\($self->{morecode});
			$nametb->{variable}=\($self->{name});
		}
		########NOTES
		#Every x value 200 is added to because the control panel on the left side takes up 200
		#Everything is multiplied by $zoom so that changing the zoom variable scales everything
		#The view_x and view_y variables are added and subtracted from x and y values to make up for the areas not shown.
	}
	
	sub draw
	{
		my($self)=@_;
		if($self->{inview})
		{#If the object is in the window view, draw it.
			
			my $color=1;#Determine the color.
			if($zmax>$zmin)
			{$color=int((($self->{z}+$self->{zsize}-$zmin)/($zmax-$zmin))*25);
			$color=24 if($color>24);$color=1 if($color<1)};
			
			$app->fill($self->{bdrect}, $bdcolor);
			$app->fill($self->{mainrect}, $fgcolorarray[$color]) unless(($self->{xsize}*$zoom<8||$self->{ysize}*$zoom<8)&&$self->{selected});#Draw the object. If the object is selected and too small to have a border, make the entire object purple by not drawing the mainrect.
			$textfont->print($app,$self->{textx},$self->{texty},$self->{mapobjecttype}) if($self->{displaytext});
		}
		$self->{selected}=0;#Make it check if the object is selected next frame.
	}
	
	sub keydown
	{
		my($self,$key)=@_;
		my $deletion=0;
		$self->{x}-=$movementsnap if($self->{selected}&&$key eq "left"&&$shiftdown);
		$self->{x}+=$movementsnap if($self->{selected}&&$key eq "right"&&$shiftdown);
		$self->{y}-=$movementsnap if($self->{selected}&&$key eq "up"&&$shiftdown);
		$self->{y}+=$movementsnap if($self->{selected}&&$key eq "down"&&$shiftdown);
		if($key eq "mb1"
		&&($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom
		&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom
		&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom
		&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom
		&&$event->motion_x()>200&&$event->motion_y()<$window_height-200)
		{#if clicking on this object, also make sure the cursor's not in the control panel.
			if($xdown)
			{#Kill the object if x is being held down
				if($self->{selected})
				{#If this object and multiple other objects are selected, delete them all.
					$_->instance_destroy() foreach(@selected);
					@selected=();
				}
				else
				{#Otherwise, just delete this one.
					$self->instance_destroy();#kill the object, leave the event by returning
				}
				$deletion=1;#skip over the selecting.
			}

			if($shiftdown)
			{#Shift means movement or resizing
				##FIRST, WE CHECK for group movement, moving multiple objects at once.
				if(@selected>=2   &&   $self->{selected}
				&&($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom)
        			{#if more than 2 objects are selected, move then all at once.
        					$self->{mousedown}=1;
						$self->{movementtype}=12;
						$self->{mousestart_x}=$event->motion_x()/$zoom-$self->{x};
        					$self->{mousestart_y}=$event->motion_y()/$zoom-$self->{y};
        					$self->{view_xold}=$view_x;
        					$self->{view_yold}=$view_y;
        					$groupmovement=1;
        			}#OTHERWISE it may be moving or resizing just this object!
				elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom+6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom-6)
				{#If shift is being held down and the mouse is in the center of the object (not the edges for resizing), move the object
					if(@selected<=1)
					{
						#If only this object or no objects are selected.
						$self->{mousedown}=1;
						$self->{movementtype}=1;
						#Store the beginning position of the mouse so that we can calculate how far to move the object when the mouse is moved
						$self->{mousestart_x}=$event->motion_x()/$zoom-$self->{x};
        					$self->{mousestart_y}=$event->motion_y()/$zoom-$self->{y};
        					#Store the beginning position of the view so that we can calculate how far to move the object when the view is moved
        					$self->{view_xold}=$view_x;
        					$self->{view_yold}=$view_y;
        				}
        			}
        			
        			elsif(($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)>$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom-$self->{ysize}*$zoom+6)
        			{#They're not moving, so maybe they're resizing. Check all 8 directions that could be resized
        				$self->{mousedown}=1;$self->{movementtype}=2;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom-$self->{ysize}*$zoom+6)
        			{	$self->{mousedown}=1;$self->{movementtype}=3;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom+$self->{ysize}*$zoom-6)
        			{	$self->{mousedown}=1;$self->{movementtype}=4;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)>$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom+$self->{ysize}*$zoom-6)
        			{	$self->{mousedown}=1;$self->{movementtype}=5;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom+6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom-6)
        			{	$self->{mousedown}=1;$self->{movementtype}=6;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom
				&&($event->motion_x()-200+$view_x)>$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom+6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom-6)
        			{	$self->{mousedown}=1;$self->{movementtype}=7;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom-$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom-$self->{ysize}*$zoom+6)
        			{	$self->{mousedown}=1;$self->{movementtype}=8;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}elsif(($event->motion_x()-200+$view_x)>$self->{x}*$zoom-$self->{xsize}*$zoom+6
				&&($event->motion_x()-200+$view_x)<$self->{x}*$zoom+$self->{xsize}*$zoom-6
				&&($event->motion_y()+$view_y)<$self->{y}*$zoom+$self->{ysize}*$zoom
				&&($event->motion_y()+$view_y)>$self->{y}*$zoom+$self->{ysize}*$zoom-6)
        			{	$self->{mousedown}=1;$self->{movementtype}=9;
        				$self->{mousestart_x}=$event->motion_x()/$zoom;$self->{mousestart_y}=$event->motion_y()/$zoom;
        				$self->{start_x}=$self->{x};$self->{start_y}=$self->{y};$self->{start_xsize}=$self->{xsize};
        				$self->{start_ysize}=$self->{ysize};$self->{view_xold}=$view_x;$self->{view_yold}=$view_y;
        			}
        			#############Ugliest section of code ever ^^^ It just checks if the mouse is in corners or sides of the object, so its just a bunch of "if mouse_x is less than this corner",etc
			}
			
			
			if(!$groupmovement&&!$deletion)
			{
				unless($ctrldown)
        			{#If ctrl is not held down, make this the only selected object
        				@selected=();
        				push(@selected,$self);
        			}
        			else
        			{#If ctrl is held down, add this object to the selected objects.
        				#Remove this object from selected objects if its already selected. Do not do this if shift is held down, otherwise no-snap with ctrl would not work. Else, add it to the selected objects.
        				if($self->{selected}){@selected=grep($_!=$self,@selected) unless($shiftdown);}
        				else{push(@selected,$self);}
        			}
        		}
		}
	}
	
	sub keyup
	{
		my($self,$key)=@_;
		$self->{mousedown}=0 if($key eq "mb1");#set #down to false if its being released
		$self->{movementtype}=0 if($key eq "mb1");
	}
	
	sub updaterects
	{
		my($self)=@_;
		
		my $resetxsize=0;
		if($self->{xsize}==0.125)
		{	$resetxsize=1;#Draw teleporters of 0.125 xsize as 1 xsize
			$self->{xsize}=1;
		}
		
		#Update the rect's depending on the new postitions and sizes
		my $tempselected=$self->{selected}*3+1;#If it is selected, $selected will be 4, otherwise it will be 1. Multiply the border width by this value.
		my $tempsmall=($self->{xsize}*$zoom>8&&$self->{ysize}*$zoom>8);#If the object is too small to have a border, remove it.
		$tempsmall=1 if($self->{xsize}*$zoom>3&&$self->{ysize}*$zoom>3&&!$self->{selected});
		
		###Set up the position of all the rectangles based on zoom, view, x, y, xsize, ysize.
		$self->{mainrect}->x(int(($self->{x}-$self->{xsize})*$zoom+(1*$tempselected*$tempsmall)+200-$view_x));
		$self->{mainrect}->y(int(($self->{y}-$self->{ysize})*$zoom+(1*$tempselected*$tempsmall)-$view_y));
		$self->{bdrect}->x(int(($self->{x}-$self->{xsize})*$zoom+200-$view_x));
		$self->{bdrect}->y(int(($self->{y}-$self->{ysize})*$zoom-$view_y));
		$self->{mainrect}->width(int(($self->{xsize}*2)*$zoom-(2*$tempselected*$tempsmall)));
		$self->{mainrect}->height(int(($self->{ysize}*2)*$zoom-(2*$tempselected*$tempsmall)));
		$self->{bdrect}->width(int($self->{xsize}*2*$zoom));
		$self->{bdrect}->height(int($self->{ysize}*2*$zoom));
		$self->{textx}=int($self->{x}*$zoom-$view_x+200-9);
        	$self->{texty}=int($self->{y}*$zoom-$view_y-7);
        	$self->{displaytext}=($self->{mainrect}->width>18&&$self->{mainrect}->height>14);
        	$self->{inview}=
        	($self->{bdrect}->x+$self->{bdrect}->width>200&&
        	$self->{bdrect}->x<$window_width&&
        	$self->{bdrect}->y+$self->{bdrect}->height>0&&
        	$self->{bdrect}->y<$window_height-200);
        	
        	$self->{xsize}=0.125 if($resetxsize);#reset it back
	}
	
	sub checkz
	{
		my($self)=@_;
		#Check if Z is in range of zmin and zmax.
		$self->{savecheckz}=(($self->{z}>=$zmin&&$self->{z}<=$zmax)||($self->{z}+$self->{zsize}<=$zmax&&$self->{z}+$self->{zsize}>=$zmin)||($self->{z}<=$zmin&&$self->{z}+$self->{zsize}>=$zmax));
		return $self->{savecheckz};
	}
	
package textbox;
	BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{
		my($self)=@_;
		$self->{usedrawevent}=1;#INit varialbes
		$self->{value}="0";#The value that the textbox holds
		$self->{x}=50;#Position
		$self->{y}=50;
		$self->{width}=100;
		$self->{height}=20;
		$self->{bdrect}=new SDL::Rect(-x=>$self->{x}, -y=>$self->{y}, -width=>$self->{width}, -height=>$self->{height});#Rects
		$self->{colorrect}=new SDL::Rect(-x=>$self->{x}+1, -y=>$self->{y}+1, -width=>$self->{width}-2, -height=>$self->{height}-2);
		$self->{typingrect}=new SDL::Rect(-x=>$self->{x}+2, -y=>$self->{y}+4, -width=>1, -height=>12);#The rect for the flashy line where typing happens
		$self->{textboxtype}="number";
		$self->{allownewlines}=0;$self->{allowslashes}=0;
		$self->{typingrectcolor}=0;
		$self->{typingrectposition}=0;
		$self->{variable}=0;#\$zoom; #store a pointer to the variable this textbox will be updating.
		$self->{depth}=-999999999999999999999;#Make sure it appears on top of controller.
		$self->{objecttype}="textbox";
          
          #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
          #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
          #$self->{bugged}=ref($textboxfont->width("a")) eq 'ARRAY';#some sdl_perl have a bug where width gives a (width,height) array.
	}
	
	sub frame
	{
		my($self)=@_;
		if($selectedtextbox==$self)
		{
			$view_x+=15 if($left);#If a textbox is selected, and left and right are used to move the typing rect. Undo view movement.
			$view_x-=15 if($right);
			$self->{typingrectcolor}++;#Set a timer for changing the color
			$self->{typingrectcolor}=0 if($self->{typingrectcolor}>40);#Update typing rect
               
               
               #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
               #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
               #if($self->{bugged})
			#{$self->{typingrect}->x(${$textboxfont->width(substr($self->{value},0,$self->{typingrectposition}))}[0]+$self->{x}+2);#set x
               #}else{$self->{typingrect}->x($textboxfont->width(substr($self->{value},0,$self->{typingrectposition}))+$self->{x}+2);}
		
          
               if($self->{allownewlines})
			{#If there are multiple lines, figure out where the typing rect should go.
				my $tempvalue=substr($self->{value},0,$self->{typingrectposition});
				my @temparray=split(/#/,$tempvalue);
				$self->{typingrect}->y(($tempvalue=~tr/#//)*20+$self->{y}+4);
				if($#temparray>-1)
				{                              
                         my $realwidth=0;
                         #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
                         #COMMENTED OUT BECAUSE IT WAS CAUSING ERRORS. NOW IT WILL NO LONGER SHOW THE BLINKY CURSOR IN THE RIGHT LOCATION
                         #if($self->{bugged})
                         #{$realwidth=${$textboxfont->width($temparray[$#temparray])}[0];}
                         #else{$realwidth=$textboxfont->width($temparray[$#temparray]);}
                         
					$realwidth=0 if(substr($tempvalue,-1,1) eq "#");
					$self->{typingrect}->x( $realwidth+$self->{x}+2 );
				}
			}
		}
	}
	
	sub keydown
	{
		my($self,$key)=@_;
		if($self->{variable}==0){return 0;}
		if($key eq "mb1"
		&&$event->motion_x() > $self->{x}   &&   $event->motion_x() < $self->{x}+$self->{width}
		&&$event->motion_y() > $self->{y}   &&   $event->motion_y() < $self->{y}+$self->{height})
		{
			#If they click the textbox...
			$selectedtextbox=$self;#make this textbox selected
			$self->{typingrectcolor}=0; #make sure the typing rect is black when it is first selected
			$self->{typingrectposition}=length($self->{value});#make the typing rect appear at the end of the string
		}
		if($selectedtextbox==$self)
		{
			if($self->{textboxtype} eq "number"&&$key =~ /^\[?[\d\.\-]\]?$/ && length($self->{value})<($self->{width}/5)*($self->{height}/20))
			{
				#If the text box allows only numbers... Check if key is a digit or a - or a . with [\d\/-]. Numpads add [] around the buttons pressed, so ignore those with \[? and \]?
				$key =~ s/^\[?([\d\.-])\]?$/$1/;#Remove the [ and ] if they exist
				substr($self->{value},$self->{typingrectposition},0)=$key;
				$self->{typingrectposition}+=1;
				$self->updatevar() unless($self->{value} !~ /\d/);
				
			}
			elsif($self->{textboxtype} eq "all"&&($key =~ /^\[?[\d\.\-a-z]\]?$/ || $key eq "space") && length($self->{value})<($self->{width}/5)*($self->{height}/20))
			{
				#If the text box allow numbers, letters and spaces... Check if key is a digit or a - or a . with [\d\/-]. Numpads add [] around the buttons pressed, so ignore those with \[? and \]?
				$key =~ s/^\[?([\d\.-])\]?$/$1/;#Remove the [ and ] if they exist
				if($shiftdown&&$key=~/^[a-z]$/){$key="\u$key";}
				$key = " " if($key eq "space");
				substr($self->{value},$self->{typingrectposition},0)=$key;
				$self->{typingrectposition}+=1;
				$self->updatevar();
			}
			elsif(($key eq "backspace" || $key eq "delete") && $self->{typingrectposition}>0)
			{
				#if they press backspace or delete, delete the character to the left of the typing rect.
				substr($self->{value},$self->{typingrectposition}-1,1)='';#Delete the last character.
				$self->{typingrectposition}-=1;
				$self->updatevar() unless($self->{value} !~ /\d/&&$self->{textboxtype} eq "number");
			}
			elsif(($key eq "enter"||$key eq "return")&&$self->{allownewlines})
			{
				substr($self->{value},$self->{typingrectposition},0)="#";
				$self->{typingrectposition}+=1;
			}
			elsif($self->{allowslashes}&&($key eq "/"||$key eq "\\"||$key eq ";")&& length($self->{value})<($self->{width}/5)*($self->{height}/20))
			{
				$key=":" if $key eq ";";
				substr($self->{value},$self->{typingrectposition},0)=$key;
				$self->{typingrectposition}+=1;
			}
			
			if($key eq "left"&&$self->{typingrectposition}-1>=0)
			{$self->{typingrectposition}-=1;$self->{typingrectcolor}=0;}
			if($key eq "right"&&$self->{typingrectposition}+1<=length($self->{value}))
			{$self->{typingrectposition}+=1;$self->{typingrectcolor}=0;}
		}
	}
	
	sub draw
	{
		my($self)=@_;
		$self->checkvar();
		$app->fill($self->{bdrect},$black);#Make the border
		$app->fill($self->{colorrect},($selectedtextbox==$self) ? $selection : $lightgray);#Draw white if selected, draw gray if not selected.
		if($selectedtextbox==$self)
		{
			#If this is the selected textbox, then show the typing rect
			$app->fill($self->{typingrect},($self->{typingrectcolor}>19) ? $selection : $black);
		}
		
		my $i=0;
		foreach(split(/#/,$self->{value}))
		{
			$textboxfont->print($app,$self->{x}+2,$self->{y}+2+$i*20,$_) if($_ ne "");#Print the value
			$i++;
		}
	}
	
	sub updaterects
	{
		my($self)=@_;
		$self->{bdrect}->x($self->{x});
		$self->{bdrect}->y($self->{y});
		$self->{bdrect}->width($self->{width});
		$self->{bdrect}->height($self->{height});
		
		$self->{colorrect}->x($self->{x}+1);
		$self->{colorrect}->y($self->{y}+1);
		$self->{colorrect}->width($self->{width}-2);
		$self->{colorrect}->height($self->{height}-2);
		
		$self->{typingrect}->x($self->{x}+2);
		$self->{typingrect}->y($self->{y}+4);
		$self->{typingrect}->width(1);
		$self->{typingrect}->height(12);
	}
	
	sub updatevar
	{
		my($self)=@_;
		#call this to update the variable this textbox is editing.
		${$self->{variable}}=$self->{value} unless($self->{variable}==0);
	}
	
	sub checkvar
	{
		my($self)=@_;
		#call this to check if the real variable has changed.
		
		
		unless($self->{variable} eq "0")
		{if(${$self->{variable}} ne $self->{value}&&$selectedtextbox != $self)
		{
			$self->{value}=${$self->{variable}} unless($self->{textboxtype} eq "number"&&$self->{value} !~ /\d/);
		}}
	}
	
package objectselector;#selecting what object to place
BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{
		my($self)=@_;
		$self->{objecttype}="objectselector";
		$self->{depth}=-999999999999999999999;#Make sure it appears on top of controller.
		$self->{usedrawevent}=1;
		$objecttypeselected="Bx";#What object is selected
		$self->{positions}={"330" => "Bx", "345" => "Py", "360" => "MB", "375" => "MP", "390" => "RB", "405" => "GB", "420" => "BB", "435" => "PB", "450" => "Tp", "465" => "Ac", "480" => "Cn", "495" => "Sp", "510" => "Wp"};#Store the postitions of the text in a hash.
	}
	
	sub keydown
	{
		my($self,$key)=@_;
		if($key eq "mb1"&&$event->motion_x()>0&&$event->motion_x()<120&&$event->motion_y()>330&&$event->motion_y()<525)
		{#If they're clicing on 
			$objecttypeselected=${$self->{positions}}{int($event->motion_y()/15)*15};#pick the correct one out of the hash and select it.
		}
	}
	
	sub draw
	{
		my($self)=@_;
		$controlfontred->print($app,10,310,"Place what object?");#Show all object types. Make the selected one red.
		($objecttypeselected eq "Bx") ? $controlfontred->print($app,10,330,"Bx  (Box)") : $controlfont->print($app,10,330,"Bx  (Box)");
		($objecttypeselected eq "Py") ? $controlfontred->print($app,10,345,"Py  (Pyramid)") : $controlfont->print($app,10,345,"Py  (Pyramid)");
		($objecttypeselected eq "MB") ? $controlfontred->print($app,10,360,"MB  (Mesh Box)") : $controlfont->print($app,10,360,"MB  (Mesh Box)");
		($objecttypeselected eq "MP") ? $controlfontred->print($app,10,375,"MP  (Mesh Pyr)") : $controlfont->print($app,10,375,"MP  (Mesh Pyr)");
		($objecttypeselected eq "RB") ? $controlfontred->print($app,10,390,"RB  (Red Base)") : $controlfont->print($app,10,390,"RB  (Red Base)");
		($objecttypeselected eq "GB") ? $controlfontred->print($app,10,405,"GB  (Green Base)") : $controlfont->print($app,10,405,"GB  (Green Base)");
		($objecttypeselected eq "BB") ? $controlfontred->print($app,10,420,"BB  (Blue Base)") : $controlfont->print($app,10,420,"BB  (Blue Base)");
		($objecttypeselected eq "PB") ? $controlfontred->print($app,10,435,"PB  (Purple Base)") : $controlfont->print($app,10,435,"PB  (Purple Base)");
		($objecttypeselected eq "Tp") ? $controlfontred->print($app,10,450,"Tp  (Teleporter)") : $controlfont->print($app,10,450,"Tp  (Teleporter)");
		($objecttypeselected eq "Ac") ? $controlfontred->print($app,10,465,"Ac  (Arc)") : $controlfont->print($app,10,465,"Ac  (Arc)");
		($objecttypeselected eq "Cn") ? $controlfontred->print($app,10,480,"Cn  (Cone)") : $controlfont->print($app,10,480,"Cn  (Cone)");
		($objecttypeselected eq "Sp") ? $controlfontred->print($app,10,495,"Sp  (Sphere)") : $controlfont->print($app,10,495,"Sp  (Sphere)");
		($objecttypeselected eq "Wp") ? $controlfontred->print($app,10,510,"Wp  (Weapon)") : $controlfont->print($app,10,510,"Wp  (Weapon)");
	}

package saveload;#selecting what object to place
	BEGIN{our @ISA = qw(objectdefault);}
	sub create
	{
		my($self)=@_;
		$self->{objecttype}="saveload";
		$self->{depth}=-9999999999999999999999;#Make sure it appears on top of controller.
		$self->{usedrawevent}=1;
		$self->{saverect}=new SDL::Rect(-x=>145, -y=>28, -width=>50, -height=>17);
		$self->{loadrect}=new SDL::Rect(-x=>145, -y=>73, -width=>50, -height=>17);
	}
	
	sub draw
	{
		my($self)=@_;
		$app->fill($self->{saverect},$black);#fill in rectangles
		$app->fill($self->{loadrect},$black);
		$controlfontblack->print($app,155,29,"Save");
		$controlfontblack->print($app,155,74,"Load");
	}
	
	sub keydown
	{
		my($self,$key)=@_;
		if($key eq "mb1")
		{
			if($event->motion_x()>145&&$event->motion_x()<195&&$event->motion_y()>28&&$event->motion_y()<45)
			{#If they click on the save button
				if(length($save)>4)
				{#And the filename is long enough, ask if they wanna save
					$app->fill(0,$black);
					$largeredfont->print($app,50,50,"Save map to");
					$largeredfont->print($app,50,90,"$save? (Y/N)");
					$app->sync();@frozen=("y","n");@keydowns=();$frozentype="save";
				}
				else
				{#Otherwise tell them the filename is too short
					$app->fill(0,$black);
					$largeredfont->print($app,50,50,"The filename must be");
					$largeredfont->print($app,50,90,"more than 4 characters.");
					$app->sync();@frozen=("all");@keydowns=();$frozentype="ok";
				}
			}
			if($event->motion_x()>145&&$event->motion_x()<195&&$event->motion_y()>73&&$event->motion_y()<90)
			{#if they click the load button...
				if(-e $load)
				{
					$app->fill(0,$black);
					$largeredfont->print($app,50,50,"Load map from");
					$largeredfont->print($app,50,90,"$load? (Y/N)");
					$app->sync();@frozen=("y","n");@keydowns=();$frozentype="load";
				}
				else
				{
					$app->fill(0,$black);
					$largeredfont->print($app,50,50,"File $load");
					$largeredfont->print($app,50,90,"doesn't exist.");
					$app->sync();@frozen=("all");@keydowns=();$frozentype="ok";
				}
			}
		}
	}
	
	sub unfreeze
	{
		my($self,$key,$freezename)=@_;
		if($freezename eq "save"&&$key eq "y")
		{#They hit Yes to save
			if(-e $save)
			{#if the file already exists ask them if they wanna replace it.
				$app->fill(0,$black);
				$largeredfont->print($app,50,50,"File already exists.");
				$largeredfont->print($app,50,90,"Replace it? (Y/N)");
				$app->sync();@frozen=("y","n");@keydowns=();$frozentype="replace";
			}
			else
			{#otherwise, save.
				$self->save($save);
			}
			#They want to save! Save it.
		}
		
		if($freezename eq "replace" && $key eq "y")
		{#If they chose yes to replacing, then save.
			$self->save($save);
		}
		
		if($freezename eq "load"&&$key eq "y")
		{
			$self->load($load);
		}
	}
	
	sub save
	{
		my ($self,$filename)=@_;
		open(SAVEFILE,">$filename");#Open the file
		print SAVEFILE $extracode, "\n\n\n";#add in all extra code.
		foreach(@objects)
		{#Go thru all objects
			if($_->{objecttype} eq "box")
			{#make sure the object is a box.
				if($_->{mapobjecttype} eq "Bx"){print SAVEFILE "box\n";}#Print the object type
				if($_->{mapobjecttype} eq "Py"){print SAVEFILE "pyramid\n";}
				if($_->{mapobjecttype} eq "MB"){print SAVEFILE "meshbox\n";}
				if($_->{mapobjecttype} eq "MP"){print SAVEFILE "meshpyr\n";}
				if($_->{mapobjecttype} eq "RB"){print SAVEFILE "base\ncolor 1\n";}
				if($_->{mapobjecttype} eq "GB"){print SAVEFILE "base\ncolor 2\n";}
				if($_->{mapobjecttype} eq "BB"){print SAVEFILE "base\ncolor 3\n";}
				if($_->{mapobjecttype} eq "PB"){print SAVEFILE "base\ncolor 4\n";}
				if($_->{mapobjecttype} eq "Tp"){print SAVEFILE "teleporter\n";}
				if($_->{mapobjecttype} eq "Ac"){print SAVEFILE "arc\n";}
				if($_->{mapobjecttype} eq "Cn"){print SAVEFILE "cone\n";}
				if($_->{mapobjecttype} eq "Sp"){print SAVEFILE "sphere\n";}
				if($_->{mapobjecttype} eq "Wp"){print SAVEFILE "weapon\n";}
				print SAVEFILE "name ",$_->{name}, "\n";#print name
				print SAVEFILE "position ",$_->{x}, " ",$_->{y}, " ",$_->{z}, "\n";#print x y z
				print SAVEFILE "size ",$_->{xsize}, " ",$_->{ysize}, " ",$_->{zsize}, "\n";#print xsize ysize zsize
				print SAVEFILE join("\n",split(/#/,$_->{morecode}));print SAVEFILE "\n" if($_->{morecode});#And extra code
				print SAVEFILE "end\n\n";#Print end
			}
		}
		close(SAVEFILE);
		$app->fill(0,$black);#Print a "SAVED" message.
		$largeredfont->print($app,50,50,"Your map has");
		$largeredfont->print($app,50,90,"been saved.");
		$app->sync();@frozen=("all");@keydowns=();$frozentype="ok";
	}
	
	sub load
	{
		my ($self,$filename)=@_;
		open(LOADFILE,"$filename");#Open the file
		my $inobject=0;#Set to true when between starting line e.g. "box" and the ending line, "end".
		my $newobject="";#Store created boxes in here. So we can set attributes.
		$extracode="";
		foreach(@objects)
		{$_->instance_destroy() if($_->{objecttype} eq "box");}#Remove all objects.
		foreach(<LOADFILE>)
		{
			chomp($_);
			
			if($inobject)
			{#We are currently between a starting line and the "end" line! Set the attributes of the created box.
				if(/^\s*(name|position|size|color|end)([#\s].*)??$/)
				{
					if(/^\s*name\s*(\w+)([#\s].*)??$/)
					{#The name line
						$newobject->{name}=$1;
					}
					elsif(/^\s*position\s+(\-?\d*\.?\d+)\s+(\-?\d*\.?\d+)\s+(\-?\d*\.?\d+)([#\s].*)??$/)
					{#Position # # # line
						$newobject->{x}=$1;$newobject->{y}=$2;$newobject->{z}=$3;
					}
					elsif(/^\s*size\s+(\-?\d*\.?\d+)\s+(\-?\d*\.?\d+)\s+(\-?\d*\.?\d+)([#\s].*)??$/)
					{#Size # # # line
						$newobject->{xsize}=$1;$newobject->{ysize}=$2;$newobject->{zsize}=$3;
					}
					if($newobject->{mapobjecttype} eq "RB"&&/^\s*color\s*(\d+)([#\s].*)??$/)
					{#The color line
						if($1 eq "1"){$newobject->{mapobjecttype}="RB";}
						elsif($1 eq "2"){$newobject->{mapobjecttype}="GB";}
						elsif($1 eq "3"){$newobject->{mapobjecttype}="BB";}
						elsif($1 eq "4"){$newobject->{mapobjecttype}="PB";}
					}
					elsif(/^\s*end([#\s].*)??$/)
					{#The end line
						$newobject->{depth}=-($newobject->{z}+$newobject->{zsize});
						$inobject=0;#Start to look for a new object.
					}
				}
				else
				{#Otherwise, we cant understand that code! Just add it to the objects more code.
					s/(\s{2,}|[	])/ / while(/(\s{2,}|[	])/);#Remove duplicate whitespace, replace tabs with spaces.
					s/^\s*//; s/\s*$//; #Remove trailing and leading whitespace
					$newobject->{morecode}.=$_."#"; #add it to the object's more code.
				}
			}
			elsif(/^\s*(box|pyramid|meshbox|meshpyr|base|teleporter|arc|cone|sphere|weapon)([#\s].*)??$/)
			{#We're NOT inside an object, look for one of the above starting lines.
				$newobject=new box;#Check if it's an object with that regular expression. Store the object type.
				if($1 eq "box"){$newobject->{mapobjecttype}="Bx";}
				elsif($1 eq "pyramid"){$newobject->{mapobjecttype}="Py";}
				elsif($1 eq "meshbox"){$newobject->{mapobjecttype}="MB";}
				elsif($1 eq "meshpyr"){$newobject->{mapobjecttype}="MP";}
				elsif($1 eq "base"){$newobject->{mapobjecttype}="RB";#find what color the base is later from the "color" line. If no color line it will just stick with red.
				}elsif($1 eq "teleporter"){$newobject->{mapobjecttype}="Tp";}
				elsif($1 eq "arc"){$newobject->{mapobjecttype}="Ac";}
				elsif($1 eq "cone"){$newobject->{mapobjecttype}="Cn";}
				elsif($1 eq "sphere"){$newobject->{mapobjecttype}="Sp";}
				elsif($1 eq "weapon"){$newobject->{mapobjecttype}="Wp";}
				$inobject=1;#Set the attributes of the created box until the end line is found.
			}
			elsif($_!~/^\s*$/)
			{#otherwise... we cant understand the code. Check if its more than just whitespace,then save it so you can re-add it when saving.
				$extracode.=$_."\n";
			}
		}
		close(LOADFILE);#Close the file
		$ctrler->{sortdepthsnextframe}=1;
	}
###Why did you scroll down to the bottom of this file?